package com.qzdatasoft.comm.util;

import com.qzdatasoft.comm.util.Base64;
import com.qzdatasoft.comm.util.MacMD5;
import java.io.ByteArrayOutputStream;
import java.io.UnsupportedEncodingException;

public class AzDGCrypt {

   public static byte[] encrypt(byte[] txt, byte[] key) {
      byte[] encrypt_key = "sdfsdfdsfdsfdsfsd".getBytes();
      byte ctr = 0;
      ByteArrayOutputStream byteOut = new ByteArrayOutputStream();
      int i = 0;

      for(int j = 0; i < txt.length; j += 2) {
         ctr = ctr == encrypt_key.length?0:ctr;
         byteOut.write(encrypt_key[ctr]);
         byteOut.write(txt[i] ^ encrypt_key[ctr++]);
         ++i;
      }

      return Base64.encodeBytes(encodeKey(byteOut.toByteArray(), key)).getBytes();
   }

   public static String encrypt(String txt, String key) {
      return new String(encrypt((byte[])txt.getBytes(), (byte[])key.getBytes()));
   }

   public static String encrypt(String txt, String key, String encoding) {
      String str = null;

      try {
         str = new String(encrypt((byte[])txt.getBytes(encoding), (byte[])key.getBytes()));
      } catch (UnsupportedEncodingException var5) {
         var5.printStackTrace();
      }

      return str;
   }

   public static byte[] decrypt(byte[] txt, byte[] key) {
      txt = encodeKey(Base64.decode(txt, 0, txt.length), key);
      ByteArrayOutputStream byteOut = new ByteArrayOutputStream();

      for(int i = 0; i < txt.length; ++i) {
         byte md5 = txt[i];
         ++i;
         byteOut.write(txt[i] ^ md5);
      }

      return byteOut.toByteArray();
   }

   public static String decrypt(String txt, String key) {
      return new String(decrypt((byte[])txt.getBytes(), (byte[])key.getBytes()));
   }

   public static byte[] encodeKey(byte[] txt, byte[] encrypt_key) {
      encrypt_key = (new MacMD5()).CalcMD5(new String(encrypt_key)).toLowerCase().getBytes();
      byte ctr = 0;
      byte[] tmp = new byte[txt.length];

      for(int i = 0; i < txt.length; ++i) {
         ctr = ctr == encrypt_key.length?0:ctr;
         tmp[i] = (byte)(txt[i] ^ encrypt_key[ctr++]);
      }

      return tmp;
   }

   public static void main(String[] arg) {
      String key = "1221";
      long start = System.currentTimeMillis();

      for(int i = 0; i < 6; ++i) {
         String source = "Hello, World!中文" + i;
         String encryptTxt = encrypt((String)source, (String)key);
         System.out.println(encryptTxt);
         String decryptTxt = decrypt((String)encryptTxt, (String)key);
         System.out.println(decryptTxt);
      }

      System.out.println(System.currentTimeMillis() - start);
   }
}
